## ghdl 2.0.0+dfsg

=== doc/requirements.txt ===
-r ../pyGHDL/requirements.txt

sphinx>=3.4.2
#recommonmark>=0.7.1
python-dateutil>=2.8.1

# Sphinx Extenstions
# sphinxcontrib-textstyle>=0.2.1
# sphinxcontrib-spelling>=2.2.0
# changelog>=0.3.5
autoapi
sphinx_fontawesome>=0.0.6
sphinx_autodoc_typehints>=1.11.1

# BuildTheDocs Extensions (mostly patched Sphinx extensions)
btd.sphinx.autoprogram>=0.1.6.post1
btd.sphinx.graphviz>=2.3.1.post1
btd.sphinx.inheritance_diagram>=2.3.1.post1

=== pyGHDL/requirements.txt ===
-r libghdl/requirements.txt
-r dom/requirements.txt
-r lsp/requirements.txt
-r cli/requirements.txt

=== pyGHDL/cli/requirements.txt ===
-r ../dom/requirements.txt

pyTooling>=1.6.0
pyTooling.TerminalUI>=1.5.3
pyAttributes>=2.3.2

=== pyGHDL/dom/requirements.txt ===
-r ../libghdl/requirements.txt

pyVHDLModel==0.14.1
#https://github.com/VHDL/pyVHDLModel/archive/dev.zip#pyVHDLModel

=== pyGHDL/libghdl/requirements.txt ===
pyTooling>=1.6.0

=== src/vhdl/Makefile ===
#  Copyright (C) 2002 - 2015 Tristan Gingold
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <gnu.org/licenses>.

# Some files are automatically generated using pnodes.py
# This Makefile can be used to regenerate these files.  Generated files must
# be committed and distribued with the sources, so that users don't need to
# regenerate them (and don't need to have python installed).

PNODES=../../scripts/pnodes.py
PNODESPY=../../scripts/pnodespy.py
PYTHON=python3

DEPS=vhdl-nodes.ads vhdl-nodes.adb.in $(PNODES)

GEN_FILES=vhdl-nodes.adb \
  vhdl-nodes_meta.ads \
  vhdl-nodes_meta.adb \
  vhdl-elocations.adb \
  vhdl-elocations_meta.ads \
  vhdl-elocations_meta.adb \
  ../../pyGHDL/libghdl/vhdl/nodes.py \
  ../../pyGHDL/libghdl/vhdl/nodes_meta.py \
  ../../pyGHDL/libghdl/vhdl/tokens.py \
  ../../pyGHDL/libghdl/vhdl/elocations.py \
  ../../pyGHDL/libghdl/errorout.py \
  ../../pyGHDL/libghdl/std_names.py

NODES_FLAGS=--node-file=vhdl-nodes.ads --field-file=vhdl-nodes.adb.in \
  --template-file=vhdl-nodes.adb.in --kind-file=vhdl-nodes.ads \
  --meta-basename=vhdl-nodes_meta

ELOCATIONS_FLAGS=--node-file=vhdl-elocations.ads \
  --field-file=vhdl-elocations.adb.in --kind-file=vhdl-nodes.ads \
  --template-file=vhdl-elocations.adb.in --meta-basename=vhdl-elocations_meta

all: $(GEN_FILES)

vhdl-nodes.adb: vhdl-nodes.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) body > $@
	chmod -w $@

vhdl-nodes_meta.ads: vhdl-nodes_meta.ads.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) meta_specs > $@
	chmod -w $@

vhdl-nodes_meta.adb: vhdl-nodes_meta.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) meta_body > $@
	chmod -w $@

vhdl-elocations.adb: vhdl-elocations.adb.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) body > $@
	chmod -w $@

vhdl-elocations_meta.ads: vhdl-elocations_meta.ads.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) meta_specs > $@
	chmod -w $@

vhdl-elocations_meta.adb: vhdl-elocations_meta.adb.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) meta_body > $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/nodes.py: $(DEPS) $(PNODESPY)
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-nodes > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/nodes_meta.py: $(DEPS) $(PNODESPY)
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-meta > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/std_names.py: $(PNODESPY) ../std_names.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-names > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/tokens.py: $(PNODESPY) vhdl-tokens.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-tokens > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/elocations.py: $(PNODESPY) vhdl-elocations.ads
	$(RM) $@
	$(PNODESPY) $(ELOCATIONS_FLAGS) libghdl-elocs > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/errorout.py: $(PNODESPY) ../errorout.ads
	$(RM) $@
	$(PNODESPY) $(ELOCATIONS_FLAGS) libghdl-errorout > $@
	$(PYTHON) -m black $@
	chmod -w $@

clean:
	$(RM) -f $(GEN_FILES)

=== src/ortho/debug/Makefile ===
#  -*- Makefile -*- for the ortho-code back-end
#  Copyright (C) 2005 Tristan Gingold
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <gnu.org/licenses>.
BE=debug
ortho_srcdir=..

orthobe_srcdir=$(ortho_srcdir)/$(BE)

GNATMAKE=gnatmake
CC=gcc
CFLAGS=-g
ALL_GNAT_FLAGS=-pipe -g -gnato -gnatwaeu -gnatf -gnaty3befhkmr
GNATMAKE_FLAGS=$(ALL_GNAT_FLAGS) $(GNATFLAGS) -aI$(ortho_srcdir) -aI$(orthobe_srcdir) -aI.
SED=sed

all: $(ortho_exec)


$(ortho_exec): force $(ortho_srcdir)/$(BE)/ortho_debug.ads
	$(GNATMAKE) -o $@ $(GNATMAKE_FLAGS) ortho_debug-main \
	 -bargs -E -largs $(LDFLAGS) $(GNATLFLAGS)

clean:
	$(RM) -f *.o *.ali *~ b~*.ad? ortho_nodes-main
	$(RM) ortho_debug.ads

force:

ORTHO_BASENAME=ortho_debug

# Automatically build ortho_debug.ads from ortho_node.common.ads and
# ortho_debug.private.ads
include $(ortho_srcdir)/Makefile.inc

=== src/ortho/llvm-nodebug/Makefile ===
ortho_srcdir=..
GNATFLAGS=-gnaty3befhkmr -gnata -gnatf -gnatwael
CXX=clang++
LLVM_CONFIG=llvm-config
GNATMAKE=gnatmake
SED=sed
BE=llvm-nodebug

all: $(ortho_exec)

$(ortho_exec): $(ortho_srcdir)/llvm-nodebug/ortho_llvm.ads force llvm-cbindings.o
	$(GNATMAKE) -o $@ -aI$(ortho_srcdir)/llvm-nodebug -aI$(ortho_srcdir) \
	$(GNATFLAGS) ortho_code_main -bargs -E \
	-largs llvm-cbindings.o --LINK=$(CXX) \
	`$(LLVM_CONFIG) --ldflags --libs --system-libs` $(LDFLAGS)

llvm-cbindings.o: $(ortho_srcdir)/llvm-nodebug/llvm-cbindings.cpp
	$(CXX) -c `$(LLVM_CONFIG) --cxxflags` -o $@ $<

clean:
	$(RM) -f *.o *.ali ortho_code_main
	$(RM) b~*.ad? *~

distclean: clean


force:

.PHONY: force all clean

ORTHO_BASENAME=ortho_llvm
include $(ortho_srcdir)/Makefile.inc

=== src/ortho/llvm35/Makefile ===
ortho_srcdir=..
GNATFLAGS=-gnaty3befhkmr -gnata -gnatf -gnatwael
CXX=clang++
LLVM_CONFIG=llvm-config
GNATMAKE=gnatmake
SED=sed
BE=llvm35

all: $(ortho_exec)

$(ortho_exec): $(ortho_srcdir)/llvm35/ortho_llvm.ads force llvm-cbindings.o
	$(GNATMAKE) -o $@ -aI$(ortho_srcdir)/llvm -aI$(ortho_srcdir) \
	$(GNATFLAGS) ortho_code_main -bargs -E \
	-largs llvm-cbindings.o --LINK=$(CXX) \
	`$(LLVM_CONFIG) --ldflags --libs --system-libs` $(LDFLAGS)

llvm-cbindings.o: $(ortho_srcdir)/llvm35/llvm-cbindings.cpp
	$(CXX) -c `$(LLVM_CONFIG) --cxxflags` -o $@ $<

clean:
	$(RM) -f *.o *.ali ortho_code_main
	$(RM) b~*.ad? *~

distclean: clean


force:

.PHONY: force all clean

ORTHO_BASENAME=ortho_llvm
include $(ortho_srcdir)/Makefile.inc

=== src/ortho/mcode/Makefile ===
ortho_srcdir=..
GNATMAKE=gnatmake
GNATFLAGS=-gnaty3befhkmr -gnata -gnatf -gnatwlcru
CC=gcc
BE=mcode
SED=sed

all: $(ortho_exec)

$(ortho_exec): $(ortho_srcdir)/mcode/ortho_mcode.ads memsegs_c.o force
	$(GNATMAKE) -o $@ -g -aI$(ortho_srcdir)/mcode -aI$(ortho_srcdir) \
	-aI$(ortho_srcdir)/.. $(GNATFLAGS) -gnatw.A ortho_code_main \
	-bargs -E -largs $(LDFLAGS) memsegs_c.o #-static

memsegs_c.o: $(ortho_srcdir)/mcode/memsegs_c.c
	$(CC) -c $(CFLAGS) -o $@ $<

oread: $(ortho_srcdir)/mcode/ortho_mcode.ads force
	$(GNATMAKE) -m -o $@ -g $(GNATFLAGS) -aI../oread ortho_code_main -aI.. -largs $(LDFLAGS) memsegs_c.o

elfdump: force
	$(GNATMAKE) -m -g $(GNATFLAGS) $@

coffdump: force
	$(GNATMAKE) -m $(GNATFLAGS) $@

clean:
	$(RM) -f *.o *.ali ortho_code_main elfdump
	$(RM) b~*.ad? *~

distclean: clean


force:

.PHONY: force all clean

ORTHO_BASENAME=ortho_mcode
include $(ortho_srcdir)/Makefile.inc

=== testsuite/gna/bug22868/Makefile ===
.PHONY: default
default:
	-make works.o
	-make fails1.o
	-make fails2.o


%.o: %.vhdl
	ghdl -a $<

.PHONY: clean
clean:
	ghdl --clean
	rm *.cf

=== debian/changelog ===
ghdl (2.0.0+dfsg-2) experimental; urgency=medium

  * debian/tests/control: Add gtkwave to Depends to provide ghwdump
  * Add testsuite-show-diff-output patch to see why reference comparisons fail
  * Give $(DEB_TARGET_GNU_TYPE) to GCC configure step
  * Add --enable-multiarch to GCC backend configuration

 -- Andreas Bombe <aeb@debian.org>  Tue, 06 Dec 2022 03:15:39 +0100

ghdl (2.0.0+dfsg-1) experimental; urgency=medium

  [ Andreas Bombe ]
  * Add file exclusions for new testsuites with unclear licensing in ghdl 2.0.0
  * New upstream version 2.0.0+dfsg
  * Update debian/copyright
  * Remove configure patches for LLVM 11.1, 12, 13, not needed anymore
  * Remove clean-more, versioning, fix-build patches, applied upstream
  * Refresh and adjust patches for new upstream release
  * Add Build-Depends on texinfo for GCC backend
  * Add gcc-12.patch to allow building for GCC 12
  * Switch to GCC/GNAT 12 (Closes: #1023681)
  * Change Build-Depends on gnat-$VER to versioned depends on gnat
  * Add patch llvm-14.0.patch to allow building with LLVM 14
    (Closes: #1016411, #1017672)
  * debian/rules: Propagate error codes properly.
    Thanks to Daniel Gröber for the patch this is based on
  * debian/rules: Configure with --disable-werror
  * Disable dh_dwz as dwz has bugs trying to handle GCC 12 / LLVM 14 outputs
  * Do not install ghwdump as that is provided by the gtkwave package
  * Disable gcc-verbose-lto-link gcc patch during build as there are quoting
    issues on the GHDL side where the LLINKER variable is used
  * Add parallelize-testsuite patch from upstream git
  * Add skip-unsupported-tests patch to disable tests for unsupported features
  * debian/watch: Use /tags rather than /releases page that stopped working
  * Add GCC 12 patch to reenable C source files in gengtype.cc
  * Add gcc-12-fix-move-pragma-suppress patch from upstream git
  * Add gcc-12-more-fix-move-pragma-suppress patch from upstream git
  * Bump Standards-Version to 4.6.1, no changes needed

  [ Daniel Gröber ]
  * Fix unclean rebuild via debian/rules

 -- Andreas Bombe <aeb@debian.org>  Fri, 02 Dec 2022 02:53:49 +0100

=== debian/control ===
Source: ghdl
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Andreas Bombe <aeb@debian.org>
Build-Depends: debhelper-compat (= 13),
               gnat (>= 12), gnat (<< 13~),
               gcc-12-source <!pkg.ghdl.nogcc>,
               libisl-dev (>= 0.14) <!pkg.ghdl.nogcc>,
               libmpc-dev (>= 1.0) <!pkg.ghdl.nogcc>,
               libmpfr-dev (>= 3.0.0-9~) <!pkg.ghdl.nogcc>,
               libgmp-dev (>= 2:5.0.1~) <!pkg.ghdl.nogcc>,
               texinfo <!pkg.ghdl.nogcc>,
               llvm-dev (>= 1:3.5) <!pkg.ghdl.nollvm>,
               clang (>= 1:3.5) <!pkg.ghdl.nollvm>,
               zlib1g-dev
Standards-Version: 4.6.1
Homepage: https://github.com/ghdl/ghdl
Vcs-Browser: https://salsa.debian.org/electronics-team/ghdl/ghdl
Vcs-Git: https://salsa.debian.org/electronics-team/ghdl/ghdl.git
Rules-Requires-Root: no

Package: ghdl
Architecture: any
Depends: ghdl-common (= ${binary:Version}),
         ghdl-mcode [any-i386 any-amd64] <!pkg.ghdl.nomcode>
         | ghdl-gcc <!pkg.ghdl.nogcc>
         | ghdl-llvm <!pkg.ghdl.nollvm>,
         ${misc:Depends}
Suggests: gtkwave
Description: VHDL compiler/simulator
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 GHDL offers three machine code generation backends: one based on GCC, one
 using the LLVM compiler suite and a GHDL specific one called mcode. These are
 available in the ghdl-gcc, ghdl-llvm and ghdl-mcode packages respectively.
 Both the GCC and LLVM backends create highly optimized code for excellent
 simulation performance while simulations compiled with the GCC backend also
 allow coverage testing using gcov. The mcode backend creates less performant
 code but makes up for it with much faster compilation. It is therefore
 preferable for smaller projects without large or long running simulations.
 .
 Multiple backends can be installed at the same time and selected by either
 invoking the desired GHDL directly (as ghdl-gcc, ghdl-llvm or ghdl-mcode) or
 by providing a GHDL_BACKEND environment variable (containing gcc, llvm or
 mcode) while invoking ghdl.
 .
 This package is a dependency package that will make sure at least one backend
 is installed.

Package: ghdl-common
Architecture: any
Depends: ${misc:Depends}
Breaks: ghdl (<< 0.37+dfsg2)
Replaces: ghdl (<< 0.37+dfsg2)
Description: VHDL compiler/simulator (common files)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains common files for the GHDL compiler packages.

Package: ghdl-mcode
Architecture: any-i386 any-amd64
Build-Profiles: <!pkg.ghdl.nomcode>
Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: VHDL compiler/simulator (mcode backend)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the compiler with the mcode backend.

Package: ghdl-gcc
Architecture: any
Build-Profiles: <!pkg.ghdl.nogcc>
Built-Using: ${Built-Using-GCC}
Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
	gcc, zlib1g-dev
Description: VHDL compiler/simulator (GCC backend)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the compiler with the GCC backend.

Package: ghdl-llvm
Architecture: any
Build-Profiles: <!pkg.ghdl.nollvm>
Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
	gcc, zlib1g-dev
Description: VHDL compiler/simulator (LLVM backend)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the compiler with the LLVM backend.

=== debian/rules ===
#!/usr/bin/make -f

# Currently gcc can not be compiled with format-security and it is not needed
# for Ada code anyway
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-format

#export DH_VERBOSE = 1

# These variables are used to find and unpack the gcc source
GCC_DIR := /usr/src/gcc-12
GCC_VER := 12
GCC_TARBALL := $(notdir $(wildcard $(GCC_DIR)/gcc-*.tar.*))

include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging.mk

# This variable is used in Makefile.in to adjust src/version.in
export GHDL_VER_DESC := $(DEB_VENDOR) $(DEB_VERSION)

# Get parallel option to parallelize the gcc build specifically (Ada builds
# are already parallelized by code included from debian_packaging-*.mk above).
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEPARALLEL = -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# build profile control over what backends get built
ifeq ($(filter pkg.ghdl.nomcode,$(DEB_BUILD_PROFILES)),)
    WITH_MCODE := 1
endif
ifeq ($(filter pkg.ghdl.nogcc,$(DEB_BUILD_PROFILES)),)
    WITH_GCC   := 1
endif
ifeq ($(filter pkg.ghdl.nollvm,$(DEB_BUILD_PROFILES)),)
    WITH_LLVM  := 1
endif

# force disable mcode build on non-x86 architectures where it isn't supported
ifeq ($(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),)
    WITH_MCODE :=
endif

BUILDDIR := $(CURDIR)/builddir
TESTRUNDIR := $(CURDIR)/testrundir
CC := gnatgcc
export CC


%:
	dh ${@}

override_dh_clean:
	# An .orig file exists in the release, don't delete it to not create
	# spurious differences to the tarball/git.
	dh_clean -Xtestsuite/synth/synth14/top.vhdl.orig

override_dh_auto_clean:
	# dh_auto_clean complains about python-distutils and fails if it
	# doesn't see a Makefile, so override to only do a distclean when the
	# Makefile exists and do nothing otherwise.
	if [ -f Makefile ]; then \
		$(MAKE) distclean; \
	fi

override_dh_installdocs:
	dh_installdocs --link-doc=ghdl-common

override_dh_auto_configure:
	mkdir -p $(BUILDDIR)/mcode $(BUILDDIR)/llvm $(BUILDDIR)/gcc
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with mcode backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_MCODE)" ]; then \
		cd $(BUILDDIR)/mcode && \
		../../configure --srcdir=../.. --prefix=/usr --disable-werror \
			--libdir=lib/ghdl/mcode --incdir=lib/ghdl/include \
			--disable-libghdl --enable-gplcompat; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with llvm backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_LLVM)" ]; then \
		cd $(BUILDDIR)/llvm && \
		../../configure --srcdir=../.. --prefix=/usr --disable-werror \
			--libdir=lib/ghdl/llvm --incdir=lib/ghdl/include \
			--disable-libghdl --enable-gplcompat \
			--with-llvm-config; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with gcc backend
	@echo ------------------------------------------------------------
	# gcc unpack sequence cribbed from gcc-7-cross debian/rules
	# We have to disable the gcc-verbose-lto-link patch since it replaces
	# the LLINKER value with one that runs the linker under /usr/bin/time
	# and the spaces are not escaped properly somewhere on the ghdl side.
	set -e && \
	if [ -n "$(WITH_GCC)" ]; then \
		cd $(BUILDDIR)/gcc && \
		ln -sf ${GCC_DIR}/$(GCC_TARBALL) $(GCC_TARBALL) && \
		cp -a  ${GCC_DIR}/debian/ . && \
		if [ -n "$$(grep -v '^\#' ${CURDIR}/debian/gcc-patches/gcc-${GCC_VER}/series)" ]; then \
			cp -n ${CURDIR}/debian/gcc-patches/gcc-${GCC_VER}/*.diff debian/patches/  && \
			cat ${CURDIR}/debian/gcc-patches/gcc-${GCC_VER}/series >> debian/patches/series  && \
			sed -i "s/\(^series_stamp.*\)/debian_patches += $$(grep -v '^#' ${CURDIR}/debian/gcc-patches/gcc-${GCC_VER}/series|sed 's/\..*//'|tr '\n' ' ')\n\n\1/" debian/rules.patch ; \
		fi && \
		echo -n > $(BUILDDIR)/gcc/debian/patches/gcc-verbose-lto-link.diff && \
		debian/rules patch && \
		../../configure --srcdir=../.. --prefix=/usr --disable-werror \
			--libdir=lib/ghdl/gcc --incdir=lib/ghdl/include \
			--disable-libghdl --enable-gplcompat \
			--with-gcc=src && \
		make copy-sources && \
		mkdir -p gccbuild && \
		cd gccbuild && \
		../src/configure --prefix=/usr/lib/ghdl/gcc --enable-languages=vhdl \
			--enable-multiarch --enable-default-pie \
			--disable-bootstrap --disable-lto --disable-multilib \
			--disable-libssp --disable-libgomp --disable-libquadmath \
			--with-system-zlib --without-isl \
			$(DEB_TARGET_GNU_TYPE); \
	fi

override_dh_auto_build:
	@echo
	@echo ------------------------------------------------------------
	@echo Building with mcode backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_MCODE)" ]; then \
		$(MAKE) -C $(BUILDDIR)/mcode; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Building with llvm backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_LLVM)" ]; then \
		$(MAKE) -C $(BUILDDIR)/llvm; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Building with gcc backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_GCC)" ]; then \
		$(MAKE) $(MAKEPARALLEL) -C $(BUILDDIR)/gcc/gccbuild && \
		$(MAKE) -C $(BUILDDIR)/gcc lib/ghdl/gcc/libgrt.a all.vpi && \
		$(MAKE) -C $(BUILDDIR)/gcc ghdllib \
			GHDL_GCC_BIN=$(BUILDDIR)/gcc/gccbuild/gcc/ghdl \
			GHDL1_GCC_BIN="--GHDL1=$(BUILDDIR)/gcc/gccbuild/gcc/ghdl1"; \
	fi

override_dh_auto_install:
	install -pD debian/ghdl.wrapper $(CURDIR)/debian/tmp/usr/bin/ghdl
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with mcode backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_MCODE)" ]; then \
		$(MAKE) -C $(BUILDDIR)/mcode install DESTDIR=../../debian/tmp; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with llvm backend
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_LLVM)" ]; then \
		$(MAKE) -C $(BUILDDIR)/llvm install DESTDIR=../../debian/tmp; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with gcc backend
	@echo ------------------------------------------------------------
	# Place a symlink for the binary ahead of time so that the compilation
	# of the VHDL standard libraries works during the gcc install step. The
	# binary is properly moved afterwards.
	if [ -n "$(WITH_GCC)" ]; then \
		mkdir -p $(CURDIR)/debian/tmp/usr/bin && \
		ln -sf ../lib/ghdl/gcc/bin/ghdl-gcc $(CURDIR)/debian/tmp/usr/bin/ghdl-gcc && \
		$(MAKE) -C $(BUILDDIR)/gcc/gccbuild install \
			DESTDIR=$(CURDIR)/debian/tmp && \
		$(MAKE) -C $(BUILDDIR)/gcc install DESTDIR=$(CURDIR)/debian/tmp && \
		mv debian/tmp/usr/lib/ghdl/gcc/bin/ghdl-gcc debian/tmp/usr/bin/ghdl-gcc && \
		mv debian/tmp/usr/lib/ghdl/gcc/lib/ghdl/libbacktrace.a debian/tmp/usr/lib/ghdl/gcc/vhdl/libbacktrace.a; \
	fi
	@echo
	@echo ------------------------------------------------------------
	@echo Moving parts to required locations
	@echo ------------------------------------------------------------
	if [ -n "$(WITH_MCODE)" ]; then \
		$(RM) -r debian/tmp/usr/lib/ghdl/src && \
		mv debian/tmp/usr/lib/ghdl/mcode/vhdl/src debian/tmp/usr/lib/ghdl && \
		ln -s ../../src debian/tmp/usr/lib/ghdl/mcode/vhdl/src; \
	fi
	if [ -n "$(WITH_LLVM)" ]; then \
		$(RM) -r debian/tmp/usr/lib/ghdl/src && \
		mv debian/tmp/usr/lib/ghdl/llvm/vhdl/src debian/tmp/usr/lib/ghdl && \
		ln -s ../../src debian/tmp/usr/lib/ghdl/llvm/vhdl/src; \
	fi
	if [ -n "$(WITH_GCC)" ]; then \
		$(RM) -r debian/tmp/usr/lib/ghdl/src && \
		mv debian/tmp/usr/lib/ghdl/gcc/vhdl/src debian/tmp/usr/lib/ghdl && \
		ln -s ../../src debian/tmp/usr/lib/ghdl/gcc/vhdl/src; \
	fi

=== debian/tests/control ===
Test-Command: debian/tests/ghdl-tests autopkgtest gcc
Depends: ghdl-gcc, gtkwave
Restrictions: skip-not-installable

Test-Command: debian/tests/ghdl-tests autopkgtest llvm
Depends: ghdl-llvm, gtkwave
Restrictions: skip-not-installable

Test-Command: debian/tests/ghdl-tests autopkgtest mcode
Depends: ghdl-mcode, gcc, libc6-dev, gtkwave
Restrictions: skip-not-installable

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg(\.?\d+)?$//, repacksuffix=+dfsg, \
    filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ghdl-$1.tar.gz%" \
    https://github.com/ghdl/ghdl/tags/ \
    (?:.*?/)?v?(\d*\.[\d.]*)\.tar\.gz debian uupdate

## ghdl 3.0.0+dfsg2

=== pyGHDL/cli/requirements.txt ===
-r ../dom/requirements.txt

pyTooling>=2.11.0
pyTooling.TerminalUI>=1.5.9
pyAttributes>=2.3.2

=== pyGHDL/dom/requirements.txt ===
-r ../libghdl/requirements.txt

pyVHDLModel==0.23.0
#https://github.com/VHDL/pyVHDLModel/archive/dev.zip#pyVHDLModel

=== pyGHDL/libghdl/requirements.txt ===
pyTooling>=2.11.0

=== src/ortho/llvm4-nodebug/Makefile ===
ortho_srcdir=..
GNATFLAGS=-gnaty3befhkmr -gnata -gnatf -gnatwael
CXX=clang++
LLVM_CONFIG=llvm-config
GNATMAKE=gnatmake
SED=sed
BE=llvm4-nodebug

LLVM_LDFLAGS=$(LLVM_CONFIG) --ldflags --libs --system-libs

all: $(ortho_exec)

$(ortho_exec): $(ortho_srcdir)/llvm4-nodebug/ortho_llvm.ads force llvm-cbindings.o
	$(GNATMAKE) -o $@ -aI$(ortho_srcdir)/llvm4-nodebug -aI$(ortho_srcdir) \
	$(GNATFLAGS) ortho_code_main -bargs -E \
	-largs llvm-cbindings.o --LINK=$(CXX) \
	`$(LLVM_LDFLAGS)` $(LDFLAGS)

llvm-cbindings.o: $(ortho_srcdir)/llvm4-nodebug/llvm-cbindings.cpp
	$(CXX) -c `$(LLVM_CONFIG) --cxxflags` -o $@ $<

clean:
	$(RM) -f *.o *.ali ortho_code_main
	$(RM) b~*.ad? *~

distclean: clean


force:

.PHONY: force all clean

ORTHO_BASENAME=ortho_llvm
include $(ortho_srcdir)/Makefile.inc

=== debian/changelog ===
ghdl (3.0.0+dfsg2-1) unstable; urgency=medium

  * Add file exclusion for testsuite added in 3.0.0 containing Xilinx code
    apparently under DLA
  * Repack upstream as version 3.0.0+dfsg2
  * debian/copyright: Update with current years and new files
  * Restore patching of LLVM compiler path in modify-install-paths patch
    (Closes: 1053293)
  * Add patch fix-testsuite-stderr-output to restore fix dropped with
    parallelize-testsuite patch

 -- Andreas Bombe <aeb@debian.org>  Sun, 01 Oct 2023 04:18:29 +0200

ghdl (3.0.0+dfsg-1) unstable; urgency=medium

  [ Simon Richter ]
  * Sort release candidates before releases in uscan
  * New upstream version 3.0.0+dfsg
  * Refresh patches
  * Handle new --libghdldir option

  [ Daniel Gröber ]
  * Bump llvm-dev and add configure patch
  * Fix missing g++ builddep
  * Update libghdl binpkg soname
  * Fix --libghdl-library-path output
  * d/rules: Fix unclean rebuild by always calling make install targets

 -- Simon Richter <sjr@debian.org>  Mon, 25 Sep 2023 22:40:48 +0900

ghdl (2.0.0+dfsg-6.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Let the armhf build fail again since what was built failed the
    autopkgtest. (see #1010539)
  * Fail the build on s390x where the resulting package was broken.

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Feb 2023 09:33:36 +0200

ghdl (2.0.0+dfsg-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Adjust the autopkgtest for the ghwdump move.
  * Drop the gcc backend on armhf for now. (see #1010539)

 -- Adrian Bunk <bunk@debian.org>  Fri, 10 Feb 2023 18:49:58 +0200

ghdl (2.0.0+dfsg-6) unstable; urgency=medium

  * Upload to unstable
  * Rework debian/rules to get rid of cumbersome conditionals
  * Add gcc-distro-specs patch to add %(distro_defaults) like in gcc specs
  * Bring over ghwdump.1 man file from gtkwave and add new options
  * Work around i386 build losing one file by running make twice
  * Add allow-non-linux-mcode patch to allow build on hurd and kfreebsd
  * Add sparc-memmodel-include patch to fix gcc build on SPARC

 -- Andreas Bombe <aeb@debian.org>  Fri, 20 Jan 2023 03:29:12 +0100

ghdl (2.0.0+dfsg-5) experimental; urgency=medium

  * Add binary packages libghdl-2-0-0 and libghdl-dev to provide libghdl,
    which allows the yosys GHDL synthesis plugin to be packaged
  * Add ghdl-tools binary package to install ghwdump in place of the gtkwave
    package
  * Enable synth tests in debian/tests/ghdl-tests
  * Patch parallelize-testsuite: don't print informational messages on stderr
    as any output on stderr is interpreted as a failure by autopkgtest
  * Add patch psl-disable-incorrect-optimization from upstream which might fix
    the PSL testsuite failures occurring on some architectures
  * Separate the testrundir for the build testsuite fully for every backend so
    they can never interfere with each other
  * Restrict Build-Depends on llvm-dev to maximum supported version

 -- Andreas Bombe <aeb@debian.org>  Wed, 11 Jan 2023 02:57:49 +0100

ghdl (2.0.0+dfsg-4) unstable; urgency=medium

  * Upload to unstable
  * Switch configuration of gcc backend to use options from native gcc build
  * Add testsuite-pass-parameters patch to make testsuite.sh correctly pass
    command line args
  * Run testsuite with --keep-going so that all failures are recorded
  * Install ghwdump into ghdl-common /usr/lib/ghdl for use by autopkgtest
    tests as a temporary measure until ghdl can provide the ghwdump binary
    instead of gtkwave in a coordinated update
  * Enable vhpi testsuite that was added with version 2.0.0
  * Temporarily make LLVM backend testsuite failure non-fatal during build
    while investigating PSL test failures on some architectures
  * debian/copyright: Update years for Debian packaging
  * Bump Standards-Version to 4.6.2, no changes needed

 -- Andreas Bombe <aeb@debian.org>  Mon, 02 Jan 2023 18:29:21 +0100

ghdl (2.0.0+dfsg-3) experimental; urgency=medium

  [ Andreas Bombe ]
  * Use the whole build/host/target triple when configuring the GCC backend

  [ Nicolas Boulenguez ]
  * Simplify watch file
  * Use packaging.mk from dh-ada-library instead of from gnat
  * Avoid hardcoding the gnat version in debian/rules
  * Use an explicit version instead of the deprecated gnatgcc symbolic link
  * Set more build flags and tools when running ./configure
  * Simplify extraction of gcc sources
  * Simplify MAKEPARALLEL in debian/rules
  * Simplify override of dh_auto_clean
  * Simplify installation of ghdl-gcc and libbacktrace.a
  * Define common ./configure options in a Make variable
  * debian/rules: remove unneeded GCC_VER variable
  * Refresh patches with recommended options

 -- Andreas Bombe <aeb@debian.org>  Tue, 20 Dec 2022 03:46:29 +0100

=== debian/control ===
--- 
+++ 
@@ -4,17 +4,18 @@
 Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders: Andreas Bombe <aeb@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               gnat (>= 12), gnat (<< 13~),
+               dh-ada-library (>= 8.1),
+               gnat-12, gcc-12, g++-12,
                gcc-12-source <!pkg.ghdl.nogcc>,
                libisl-dev (>= 0.14) <!pkg.ghdl.nogcc>,
                libmpc-dev (>= 1.0) <!pkg.ghdl.nogcc>,
                libmpfr-dev (>= 3.0.0-9~) <!pkg.ghdl.nogcc>,
                libgmp-dev (>= 2:5.0.1~) <!pkg.ghdl.nogcc>,
                texinfo <!pkg.ghdl.nogcc>,
-               llvm-dev (>= 1:3.5) <!pkg.ghdl.nollvm>,
+               llvm-dev (<< 1:17~) <!pkg.ghdl.nollvm>,
                clang (>= 1:3.5) <!pkg.ghdl.nollvm>,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/ghdl/ghdl
 Vcs-Browser: https://salsa.debian.org/electronics-team/ghdl/ghdl
 Vcs-Git: https://salsa.debian.org/electronics-team/ghdl/ghdl.git
@@ -53,7 +54,7 @@
 
 Package: ghdl-common
 Architecture: any
-Depends: ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Breaks: ghdl (<< 0.37+dfsg2)
 Replaces: ghdl (<< 0.37+dfsg2)
 Description: VHDL compiler/simulator (common files)
@@ -102,3 +103,45 @@
  way for high speed simulation.
  .
  This package contains the compiler with the LLVM backend.
+
+Package: ghdl-tools
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: gtkwave (<< 3.3.110~)
+Replaces: gtkwave (<< 3.3.110~)
+Description: VHDL compiler/simulator (tools)
+ GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
+ GHDL is not an interpreter: it allows you to analyse and elaborate sources to
+ generate machine code from your design. Native program execution is the only
+ way for high speed simulation.
+ .
+ This package contains ghwdump, a simple command line tool to extract
+ information from GHW files produced by GHDL and display it as text. It is
+ mainly intended for use in debugging and is not needed for regular use of
+ GHDL, where a wavefile visualization tool like gtkwave would normally be used.
+
+Package: libghdl-3-0-0
+Architecture: any
+Built-Using: ${Built-Using-GCC}
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Multi-Arch: same
+Description: VHDL compiler/simulator (shared library)
+ GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
+ GHDL is not an interpreter: it allows you to analyse and elaborate sources to
+ generate machine code from your design. Native program execution is the only
+ way for high speed simulation.
+ .
+ This package contains the shared library to access GHDL internals.
+
+Package: libghdl-dev
+Architecture: any
+Built-Using: ${Built-Using-GCC}
+Depends: libghdl-3-0-0 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Description: VHDL compiler/simulator (library development files)
+ GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
+ GHDL is not an interpreter: it allows you to analyse and elaborate sources to
+ generate machine code from your design. Native program execution is the only
+ way for high speed simulation.
+ .
+ This package contains the files required to compile programs using libghdl.

=== debian/rules ===
#!/usr/bin/make -f

# Currently gcc can not be compiled with format-security and it is not needed
# for Ada code anyway
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-format

#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
include /usr/share/ada/packaging.mk

# These variables are used to find and unpack the gcc source
GCC_DIR := /usr/src/gcc-$(DEB_GNAT_VERSION)

# This variable is used in Makefile.in to adjust src/version.in
export GHDL_VER_DESC := $(DEB_VENDOR) $(DEB_VERSION)

# Get parallel option to parallelize the gcc build specifically (Ada builds
# are already parallelized by code included from debian_packaging-*.mk above).
MAKEPARALLEL = $(DEB_BUILD_OPTION_PARALLEL:%=-j%)

# List of the ghdl backends to build
BACKENDS := mcode llvm gcc

# build profile control over what backends get built
ifneq ($(filter pkg.ghdl.nomcode,$(DEB_BUILD_PROFILES)),)
    BACKENDS := $(filter-out mcode,$(BACKENDS))
endif
ifneq ($(filter pkg.ghdl.nollvm,$(DEB_BUILD_PROFILES)),)
    BACKENDS := $(filter-out llvm,$(BACKENDS))
endif
ifneq ($(filter pkg.ghdl.nogcc,$(DEB_BUILD_PROFILES)),)
    BACKENDS := $(filter-out gcc,$(BACKENDS))
endif

# force disable mcode build on non-x86 architectures where it isn't supported
ifeq ($(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),)
    BACKENDS := $(filter-out mcode,$(BACKENDS))
endif

BUILDDIR := $(CURDIR)/builddir
TESTRUNDIR := $(CURDIR)/testrundir
STAMPSDIR := $(BUILDDIR)/stamps

# Common arguments for all calls to ./configure.
# The order is the same than there.
export CC           := gcc-$(DEB_GNAT_VERSION)
export CXX          := g++-$(DEB_GNAT_VERSION)
export CFLAGS
export CXXFLAGS
export GNATMAKE     := gnatmake $(GNATMAKEFLAGS)
export ADA_FLAGS    := $(ADAFLAGS)
export LDFLAGS

# Used in 3 normal builds but not in the gcc part of the build section.
common_configure_arguments := \
  --prefix=/usr \
  --disable-werror \
  --incdir=lib/ghdl/include \
  --libnativedir=lib/$(DEB_HOST_MULTIARCH) \
  --enable-gplcompat \
 # EOL


%:
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), s390x))
 $(error This package is currently broken on s390x)
endif
	dh ${@}

override_dh_clean:
	# An .orig file exists in the release, don't delete it to not create
	# spurious differences to the tarball/git.
	dh_clean -Xtestsuite/synth/synth14/top.vhdl.orig

override_dh_auto_clean:
	# dh_auto_clean complains about python-distutils and fails if it
	# doesn't see a Makefile, so override the default build system.
	dh_auto_clean --buildsystem=makefile

override_dh_installdocs:
	dh_installdocs -pghdl -pghdl-mcode -pghdl-llvm -pghdl-gcc --link-doc=ghdl-common
	dh_installdocs --remaining-packages

override_dh_auto_configure: $(foreach backend,$(BACKENDS),$(STAMPSDIR)/configure-$(backend))

override_dh_auto_build: $(foreach backend,$(BACKENDS),$(STAMPSDIR)/build-$(backend))

override_dh_auto_install: $(foreach backend,$(BACKENDS),$(STAMPSDIR)/install-$(backend))
	@echo
	@echo ------------------------------------------------------------
	@echo Common install final steps
	@echo ------------------------------------------------------------
	install -pD debian/ghdl.wrapper $(CURDIR)/debian/tmp/usr/bin/ghdl
	cd debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) && ln -s libghdl-*.so libghdl.so
	$(RM) debian/tmp/usr/lib/ghdl/src/ieee2008/LICENSE

override_dh_dwz:
	# dwz currently has problems with some debug sections created by the
	# current LLVM compiler and would cause this step to fail.
	#dh_dwz -a -Nghdl-llvm
	# Furthermore it appears to have problems with something in
	# libghdlvpi.so and runs into assertions, so disable it altogether for
	# now.

override_dh_auto_test: $(foreach backend,$(BACKENDS),$(STAMPSDIR)/test-$(backend))

override_dh_strip:
	dh_strip -N libghdl-3-0-0
	dh_strip -p libghdl-3-0-0 --dbgsym-migration='libghdl-2-0-0'

override_dh_gencontrol:
ifneq ($(filter gcc,$(BACKENDS)),)
	dh_gencontrol -- -VBuilt-Using-GCC="$(shell dpkg-query -f '$${Source} (= $${Version})' -W gcc-$(DEB_GNAT_VERSION)-source)"
else
	dh_gencontrol
endif



$(STAMPSDIR)/configure-mcode:
	dh_testdir
	mkdir -p $(BUILDDIR)/mcode $(STAMPSDIR)
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with mcode backend
	@echo ------------------------------------------------------------
	cd $(BUILDDIR)/mcode && \
	../../configure --srcdir=../.. $(common_configure_arguments) \
		--libdir=lib/ghdl/mcode \
		--libghdldir=lib/ghdl/mcode/vhdl
	touch $@

$(STAMPSDIR)/build-mcode: $(STAMPSDIR)/configure-mcode
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Building with mcode backend
	@echo ------------------------------------------------------------
	$(MAKE) -C $(BUILDDIR)/mcode
	touch $@

$(STAMPSDIR)/install-mcode: $(STAMPSDIR)/build-mcode
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with mcode backend
	@echo ------------------------------------------------------------
	$(MAKE) -C $(BUILDDIR)/mcode install DESTDIR=../../debian/tmp
	@echo
	@echo ------------------------------------------------------------
	@echo Moving parts to required locations
	@echo ------------------------------------------------------------
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	$(RM) -r debian/tmp/usr/lib/ghdl/src
	mv debian/tmp/usr/lib/ghdl/mcode/vhdl/src debian/tmp/usr/lib/ghdl
	ln -s ../../src debian/tmp/usr/lib/ghdl/mcode/vhdl/src
	mv debian/tmp/usr/lib/ghdl/mcode/libghdl-*.so debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv debian/tmp/usr/lib/ghdl/mcode/libghdl.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

$(STAMPSDIR)/test-mcode: $(STAMPSDIR)/build-mcode
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Run testsuite for mcode backend
	@echo ------------------------------------------------------------
	# With some paths patched for the Debian packaging, the tests will not
	# work right when run from the build directory. To keep it simple
	# install into a temporary location and tell the testsuite to find ghdl
	# there.
	$(MAKE) -C $(BUILDDIR)/mcode install DESTDIR=$(TESTRUNDIR)/mcode
	debian/tests/ghdl-tests buildtest mcode
	touch $@


$(STAMPSDIR)/configure-llvm:
	dh_testdir
	mkdir -p $(BUILDDIR)/llvm $(STAMPSDIR)
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with llvm backend
	@echo ------------------------------------------------------------
	cd $(BUILDDIR)/llvm && \
	../../configure --srcdir=../.. $(common_configure_arguments) \
		--libdir=lib/ghdl/llvm \
		--libghdldir=lib/ghdl/llvm/vhdl \
		--with-llvm-config
	touch $@

$(STAMPSDIR)/build-llvm: $(STAMPSDIR)/configure-llvm
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Building with llvm backend
	@echo ------------------------------------------------------------
	$(MAKE) -C $(BUILDDIR)/llvm
	touch $@

$(STAMPSDIR)/install-llvm: $(STAMPSDIR)/build-llvm
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with llvm backend
	@echo ------------------------------------------------------------
	$(MAKE) -C $(BUILDDIR)/llvm install DESTDIR=../../debian/tmp
	@echo
	@echo ------------------------------------------------------------
	@echo Moving parts to required locations
	@echo ------------------------------------------------------------
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	$(RM) -r debian/tmp/usr/lib/ghdl/src
	mv debian/tmp/usr/lib/ghdl/llvm/vhdl/src debian/tmp/usr/lib/ghdl
	ln -s ../../src debian/tmp/usr/lib/ghdl/llvm/vhdl/src
	mv debian/tmp/usr/lib/ghdl/llvm/libghdl-*.so debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv debian/tmp/usr/lib/ghdl/llvm/libghdl.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

$(STAMPSDIR)/test-llvm: $(STAMPSDIR)/build-llvm
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Run testsuite for llvm backend
